#include <WellyNet.h>

#define COM_PIN 5                  // aka MISO / PA5
#define DND 4                      // aka DND is SCK / PA4
#define WN_ADDRESS 0x6             // my unique name

int theMessage[10];
int place = 0;
const byte servo = 7;              // Servo pin on ATTiny
unsigned int tPulse = 6000;        // Total pulse length on 20 mHz clock 6000 x 20 - speed
int hPulse = 10;                   // High pulse time 60=0deg -> 280=180deg
bool Dir = 1;                      // Servo direction

WellyNet myWelly(COM_PIN, WN_ADDRESS);

byte address = WN_ADDRESS;
byte destination = 0x5;            // Assigns destination to a variable

void setup() {
  myWelly.begin(9600);             
  pinMode(servo, OUTPUT);          // Servo is my output
}

void dancing() {
  digitalWrite(servo,HIGH);                        // Set pin high to start pulse
          delayMicroseconds(hPulse);                       // High pulse angle data
          digitalWrite(servo,LOW);                         //  Set low for the rest of pulse
          delayMicroseconds(tPulse-hPulse);
            if (hPulse < 280 && Dir ==1) hPulse+=10;       // Rotate servo to 180 degrees
            else if (hPulse >= 280 && Dir == 1){           // Servo hit upper limit
              hPulse = 180;                                // Keep servo angle in bounds
              Dir=!Dir;                                    // Switch direction
            }
            if (hPulse > 30 && Dir == 0) hPulse-=10;       // Rotate servo to 0 degrees
              else if (hPulse <= 60 && Dir == 0){          // Servo hit lower limit
                hPulse = 60;                               // Keep servo angle in bounds
                Dir=!Dir;                                  // Switch direction
              }
            delayMicroseconds(5000);                       // Give servo time to move before giving it a new position 
}

void stopping() {
  digitalWrite(servo,LOW);                                 // Set pin low to end pulse
}

uint16_t message_type(int message[]) {                     // Combine packet 3 Event/Action 4 Code
  return message[2];
}

int message_event_type(int message[]) {
  return message [3];
}

void dispatch_event_message(int message[]) {              // Each case number is an event number
  switch(message_event_type(message)) {
    case 1:
      dancing();                                          // Servo starts dancing
      break;
    case 2:
      stopping();
      break;
    default:
      stopping();
      break;
  }
}

void dispatch_action_message(int message[]) {              // Each case number is an action number
  switch(message_event_type(message)) {
    case 1:
      dancing();                                          // Servo starts dancing
      break;
    case 2:
      stopping();                        
      break;
    default:
      stopping();
      break;
  }
}

void loop() {
    if(myWelly.getPacket(theMessage)) {                    // Receive message
      int checksum = checksumCalc(theMessage);             // Check message
      if (theMessage[9] != checksum) {                      // Value 9 is packet checksum
        return;                                            // Check the message checksum, bail if it doesn't match
      }
    }
      
      if(message_type(theMessage) == 'E') {                // Check to see if message is an Event
        dispatch_event_message(theMessage);                // Sends me the event message
      }
      else {
       if(message_type(theMessage) == 'A') {               // Check to see if message is an Action
         dispatch_action_message(theMessage);               // Sends me the action message
      }
    }
}

